
// ---------------------------------------------------------------------------
//   A. Veneziani - Programma di esempio di gestione di errori a run-time
//
//                  scritto in C++ Builder 6
//
//---------------------------------------------------------------------------

#include "conio.h"
#include <vcl.h>
#include <iostream>

using namespace std;

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused


void err1()
{
      int x, y , r;

      x = 10;
      y = 0;

      try {
         r = x / y;
      }
      catch(EDivByZero &e)
      {
          cout << "Errore di divisione per zero.\n";
      }
      catch (EAccessViolation &eav)
      {
         cout << "Errore di violazione di memoria.\n";
      }
      catch(Exception &e)
      {
          cout << "Si e' verificato un errore.\n";
      }
}

void err2()
{
      int arr[10];

      try {
         arr[250] = 30;
      }
      catch(EDivByZero &e)
      {
          cout << "Errore di divisione per zero.\n";
      }
      catch (EAccessViolation &eav)
      {
         cout << "Errore di violazione di memoria.\n";
      }
      catch(Exception &e)
      {
          cout << "Si e' verificato un errore.\n";
      }
}

void err3()
{
      AnsiString st;
      int x;

      st = "125.48";

      try {

          x = StrToInt(st);
      }
      catch (EConvertError &ce)
      {
          cout << "Errore di conversione.";
      }
}

int main(int argc, char* argv[])
{
      char ch;

      cout << "Genera due tipi di errori gestiti.\n\n";
      cout << "Premi 1 per generare un errore di divisione per 0.\n";
      cout << "Premi 2 per generare un errore di accesso in memoria.\n";
      cout << "Premi 3 per generare un errore relativo ad operazioni sul filesystem.\n\n";


     do {
         ch = getch();

         switch (ch)
         {
             case '1':  err1();  break;
             case '2':  err2();  break;
             case '3':  err3();  break;
         }

     } while ((ch != '1') && (ch != '2') && (ch != '3'));

      getch();

      return 0;
}
//---------------------------------------------------------------------------

